package main

import (
	"ConspiracyDecoder/requetes"
	"crypto/tls"
	"fmt"
	"io/ioutil"
	"os"
)

func testDecode(filename string) {
	bytes, err := ioutil.ReadFile(filename)
	if (err != nil) {
		fmt.Println("Impossible de lire le fichier.")
		os.Exit(1)
	}

	requetes.ReadRequete(bytes)
}

func moreTestDecode() {
	testDecode("todecode2.log")
	testDecode("todecode3.log")
	testDecode("todecode4.log")
}

func testAutoDecodeRequest() {
	requeteBytes := requetes.CreateRequetteConnecteeBasique(requetes.NUMREQ_REQUET_MES_PARTIES)
	requetes.ReadRequete(requeteBytes)
}

func testServerRequest() {
	conf := &tls.Config{
		InsecureSkipVerify: true, //TODO Voir pour ajouter le certificat Badfrog.
	}
	var n int
	var err error
	var conn *tls.Conn

	conn, err = tls.Dial("tcp", "conspiracy.badfrog.info:26677", conf)

	if err != nil {
		fmt.Println(err)
		os.Exit(1)
	}
	defer conn.Close()

	n, err = conn.Write(requetes.CreateRequetteConnecteeBasique(requetes.NUMREQ_REQUET_MES_PARTIES))
	if err != nil {
		fmt.Println(err)
		os.Exit(1)
	}

	buf := make([]byte, 4096)
	n, err = conn.Read(buf)
	if err != nil {
		fmt.Println(err)
		os.Exit(1)
	}

	requetes.ReadRequete(buf[:n])
}

func main() {
	//testDecode("todecode1.log")
	moreTestDecode()

	testAutoDecodeRequest()

	// Tentative de connexion au serveur pour envoi d'une requête perso.
	testServerRequest()
}
