package requetes

import (
	"ConspiracyDecoder/requetes/donnees"
	"errors"
	"fmt"
	"os"
)

func ReadResultatInfoInscriptionPartie(bytes []byte) ([]donnees.InfoPartie, error) {
	size := ((int) (bytes[0] & 255) << 8) + ((int) (bytes[1] & 255))
	// (size détermine le nombre de parties / inscriptions, on ne traite ici que des parties.)

	// On crée un tableau de `size` parties.
	parties := make([]donnees.InfoPartie, size)

	if size > 0 {
		//TODO Faire une boucle pour lire toutes les parties.

		// 1 = InfoInscription, 0 = InfoPartie.
		if bytes[2] == 0 {
			// Dans le cas des informations d'une partie...
			partie, err := donnees.ReadInfoPartie(bytes[3:])
			if err != nil {
				fmt.Println(err)
				os.Exit(1)
			}
			parties[0] = partie
		} else {
			return nil, errors.New("infoinscription not handled")
		}
	}

	return parties, nil
}
